%%
%% Copyright (C) 2014, Jaguar Land Rover
%%
%% This program is licensed under the terms and conditions of the
%% Mozilla Public License, version 2.0.  The full text of the
%% Mozilla Public License is at https://www.mozilla.org/MPL/2.0/
%%


-module(rvi_common_app).

-behaviour(application).

%% Application callbacks
-export([start/2,
	 start_phase/3,
	 stop/1]).

%% ===================================================================
%% Application callbacks
%% ===================================================================

start(_StartType, _StartArgs) ->
    rvi_common_sup:start_link().

start_phase(setup_config, _, _) ->
    rvi_config:setup_substitution(rvi_core),
    ok;
start_phase(start_json_servers, _, _) ->
    rvi_log:start_json_server(),
    ok.

stop(_State) ->
    ok.
